/***************************************************************************
                          ksorcery.cpp
                             -------------------
    begin                : Sun May 12 17:28:01 EDT 2002
    copyright            : (C) 2002 by Zach Hobbs
    email                : zach@firstwavedesign.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ksorcery.h"

Ksorcery::Ksorcery(QWidget *parent, const char *name) : QMainWindow(parent, name)
{


  // Splitter to Split the KSpellList and QTabWidget widgets
  QSplitter *splitter = new QSplitter( this );
  splitter->setOpaqueResize( TRUE );
  setCentralWidget(splitter);

  // <The Left>//
  spelllist = new KSpellList( splitter, "spell list");
  
  
  // <The Right> //
  QTabWidget* tabs = new QTabWidget( splitter, "main tabs" );

  // Add Tab for Spell info
  spellinfo = new KSpellInfo( this, "spell info" );
  tabs->addTab( spellinfo, "Spell Info" );

  // Tab for Spell Editor
  KSpellEdit *spelledit = new KSpellEdit( this );
  tabs->addTab( spelledit, "Edit Spell" );

  // Add Tab for Spell Queue
  KSpellQueue *spellqueue = new KSpellQueue( this );
  tabs->addTab( spellqueue, "Spell Queue" );
  
  //-- Connections -- //

  // Update Spellinformation
  QObject::connect( spelllist, SIGNAL( selectionChanged ( QListViewItem *) ),
		    spellinfo, SLOT( updateInfo( QListViewItem *) ) );

  // Update Spellinformation
  QObject::connect( spelllist, SIGNAL( selectionChanged ( QListViewItem *) ),
		    spelledit, SLOT( updateFileList( QListViewItem *) ) );
  
  // Change Tabs
  QObject::connect( tabs, SIGNAL(  currentChanged ( QWidget * ) ),
		    tabs, SLOT(  showPage ( QWidget * ) ) );
  // Exec Command - From Spell Info
  QObject::connect( spellinfo, SIGNAL( actionTaken( QString * )),
		    this, SLOT( execCmd( QString * ) ) );
  // Exec Command - From Spell List
  QObject::connect( spelllist, SIGNAL( actionTaken( QString * )),
		    this, SLOT( execCmd( QString * ) ) );

  // Exec Command - From Spell Queue
  QObject::connect( spellqueue, SIGNAL( actionTaken( QString * )),
		    this, SLOT( execCmd( QString * ) ) );
  // Add item to queue - From list
  QObject::connect( spelllist, SIGNAL( addQueue( QString *)  ),
		    spellqueue, SLOT( addItem( QString * )) );
  
  // Add item to queue - From info actions
  QObject::connect( spellinfo, SIGNAL( addQueue( QString *)  ),
		    spellqueue, SLOT( addItem( QString * )) );
  // Misc stuff
  splitter->show();
  splitter->setResizeMode( spelllist, QSplitter::FollowSizeHint );

  spelllist->buildList();
  
}

Ksorcery::~Ksorcery()
{

}


void Ksorcery::execCmd( QString* cmd ) {

  QString* tmpCmd = new QString("konsole -e bash -c '" + *cmd + "; echo Press any key to exit; read -n 1'");

  // Here's the command:
  // konsole -e bash -c 'cmd; echo Press any key to exit; read -n 1'

  QProcess * launchKonsole = new QProcess(QString("bash"), this);

  if (!launchKonsole->launch( *tmpCmd ))
    qDebug( *tmpCmd + " didn't work!!");

}
