/***************************************************************************
                          kspellinfo.h  -  description
                             -------------------
    begin                : Sun May 12 2002
    copyright            : (C) 2002 by Zach Hobbs
    email                : zach@firstwavedesign.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSPELLINFO_H
#define KSPELLINFO_H

#include <qgroupbox.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qtextedit.h>
#include <klistview.h>
#include <qprocess.h>
#include <kurllabel.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <kregexp.h>
#include <krun.h>

/**
  *@author Zach Hobbs
  */

class KSpellInfo : public QWidget  {

Q_OBJECT

public: 
  KSpellInfo( QWidget*, const char *);
  ~KSpellInfo();

  QComboBox* actions;
  QPushButton* execAction;

private:
  QLabel* spellnameline;
  QTextEdit* spelldescriptionline;
  QLabel* spelldescriptionlabel;
  QLabel* spellversionline;
  KURLLabel* spellwebsiteline;
  QLabel* spelllicenseline;
  KURLLabel* spellmaintainerline;
  QLabel* spellsourceline;
  QProcess* getDetails;


public slots:
  void updateInfo( QListViewItem *);

private slots:
  void detailsReady();
  void actionExecClicked();
  void processMyURL( const QString& );

signals:
  void actionTaken( QString * );
  void addQueue( QString * );
};


#endif
